import controlP5.*;
ControlP5 controlP5;
CheckBox checkbox;

void controlsInit(){
  int x = 7;
  int y = 0;
  int w = int(width/7.9);
  int h = 12;
  int e = 3;
  controlP5 = new ControlP5(this);

  controlP5.addSlider("boids", 0, 400, boidsNbr, x, e, int(w*1.2), h);
  controlP5.addSlider("food", 0, 30, foodNbr, x, h+2*e, int(w*1.2), h);
  controlP5.addSlider("obst", 0, 30, obstNbr, x, 2*h+3*e, int(w*1.2), h);

  controlP5.addSlider("cohesion", 0, 50, boids.cohesion, w*2, 1 * e, int(w*1.2), h);
  controlP5.addSlider("avoidance", 0, 50, boids.avoidance, w*2, 1 * h + 2 * e, int(w*1.2), h);
  controlP5.addSlider("imitation", 0, 50, boids.imitation, w*2, 2 * h + 3 * e, int(w*1.2), h);

  controlP5.addSlider("size", 1, 20, boids.size, w*4, e, int(w*1.2), h);
  controlP5.addSlider("aura", 1, 100, boids.aura, w*4, h+2*e, int(w*1.2), h);
  controlP5.addSlider("perception", 1, 200, boids.perception, w*4, 2*h+3*e, int(w*1.2), h);

  controlP5.addSlider("food_aura", 1, 10, foodAuraFactor, w*6, e, int(w*1.2), h);
  controlP5.addSlider("obst_aura", 1, 10, obstAuraFactor, w*6, h+2*e, int(w*1.2), h);

  checkbox = controlP5.addCheckBox("canvasBounce", w*6, 2*h+3*e);  
  checkbox.setColorLabel(color(128));
  checkbox.addItem("Stay on canvas",0);

  String[] sliders = {
    "boids","food","obst", "cohesion","avoidance","imitation",
    "size","aura","perception", "food_aura", "obst_aura"  };
  for(int i=0;i<sliders.length;i++){
    Slider s = (Slider) controlP5.controller(sliders[i]);
    s.setColorLabel(color(0,0,0));
  }
}

void controlEvent(ControlEvent theEvent) {
  if(theEvent.isGroup()) {
    // canvasBounce checkbox effect
    if(theEvent.group().name() == "canvasBounce"){
      int state = (int)theEvent.group().arrayValue()[0];
      if(state==1) boids.loopZone = false;
      else boids.loopZone = true;
    }
  }
}

// sliders effects

void boids(int n) {
  // add boids
  if(n > boids.size()){
    while(boids.size()<n){
      boids.add();
    }
  }
  // remove boids
  else if(n<boids.size()){
    while(boids.size()>n){
      boids.del(0);
    } 
  }
}

void food(int n) {
  // add food
  if(n>foodList.size()){
    while(foodList.size()<n){
      foodList.add(new Obj());
    }
  }
  // remove food
  else if(n<foodList.size()){
    while(foodList.size()>n){
      foodList.remove(0);
    } 
  }
}

void obst(int n){
  // add obstacle
  if(n>obstList.size()){
    while(obstList.size()<n){
      obstList.add(new Obj());
    }
  }
  // remove obstacle
  else if(n<obstList.size()){
    while(obstList.size()>n){
      obstList.remove(0);
    } 
  }
}

void cohesion(float n){
  boids.cohesion = n;
}
void avoidance(float n){
  boids.avoidance = n;
}
void imitation(float n){
  boids.imitation = n;
}

void size(int n){
  boids.size = n;
  boids.aura = 3 * n;
  boids.perception = 10 * n;
}

void aura(float n){
  boids.aura = n;
  displayAura = true;
}

void perception(float n){
  boids.perception = n;
  displayPerception = true;
}

void food_aura(float n){
  foodAuraFactor = n;
  changeFoodAura = true;
}

void obst_aura(float n){
  obstAuraFactor = n;
  changeObstAura = true;
}



